
// Adds 100 (64h) to value of byte 1 in a dBASE file

#include <stdio.h>
#include <string.h>

void main(int argc, char *argv[])
{
   char name1[256];
   fpos_t pos;
   FILE *stream;
   size_t f_read,f_write;
   unsigned char B[1];

   if (argc != 2)
   {
      printf ("Usage:  DBTOUCH [dbf_name] \n");
      return;
   }
   strcpy(name1, argv[1]);
   if ((stream = fopen(name1,"r+b")) == NULL)
   {
      printf ("Could not open file.\n");
      return;
   }
   pos = 1;
   if (fsetpos(stream,&pos) != 0)
   {
      printf ("Error setting file pointer position.\n");
      fclose(stream);
      return;
   }
   f_read = fread(B,sizeof(unsigned char),1,stream);
   if (ferror(stream))
   {
      printf ("Error reading byte.\n");
      fclose(stream);
      return;
   }
   printf ("Old year stamp = '%d'\n",B[0]);
   if (B[0] > 69)
   {
      printf ("File is already AV30 compliant.\n");
      fclose(stream);
      return;
   }
   B[0] = B[0] + 100;
   printf ("New year stamp = '%d'\n",B[0]);
   if (fsetpos(stream,&pos) != 0)
   {
      printf ("Error resetting file pointer position.\n");
      fclose(stream);
      return;
   }
   f_write = fwrite(B,sizeof(unsigned char),1,stream);
   if (ferror(stream))
   {
      printf ("Error writing byte.\n");
   }
   fclose(stream);
   return;
}

